package org.eclipse.jdt.internal.compiler.ast;

import org.eclipse.jdt.internal.compiler.lookup.InferenceContext18;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;

public interface IPolyExpression
{
    public abstract void setExpressionContext(ExpressionContext p0);
    
    public abstract ExpressionContext getExpressionContext();
    
    public abstract void setExpectedType(TypeBinding p0);
    
    public abstract TypeBinding invocationTargetType();
    
    public abstract boolean isPotentiallyCompatibleWith(TypeBinding p0, Scope p1);
    
    public abstract boolean isCompatibleWith(TypeBinding p0, Scope p1);
    
    public abstract boolean isBoxingCompatibleWith(TypeBinding p0, Scope p1);
    
    public abstract boolean sIsMoreSpecific(TypeBinding p0, TypeBinding p1, Scope p2);
    
    public abstract boolean isPertinentToApplicability(TypeBinding p0, MethodBinding p1);
    
    public abstract boolean isPolyExpression(MethodBinding p0);
    
    public abstract boolean isPolyExpression();
    
    public abstract boolean isFunctionalType();
    
    public abstract Expression[] getPolyExpressions();
    
    public abstract TypeBinding resolveType(BlockScope p0);
    
    public abstract Expression resolveExpressionExpecting(TypeBinding p0, Scope p1, InferenceContext18 p2);
}
